%Author: Pavan Tallapragada

function G2_unif = Gamma2_uniform(p, Par)

T = Par.T;
A = Par.A;
beta = Par.beta;
w = Par.w;
theta = Par.theta;

cs1 = exp((w+theta)*T);
cs2 = (cs1 - 1)/(2^p);

G2_unif = -1;

opts = optimset('MaxFunEvals',1e4,'MaxIter',1e4,'display','none',...
                'tolx',1e-6);
[G2_unif,fval,EXITFLAG] = fminbnd(@nested_fun,0,T,opts);

    function fval = nested_fun(t)
        gfun = cs2*( norm(expm(A*t),Inf)*exp(beta*t/2) )/...
               ( cs1 - exp((w+theta)*t) );
        
        fval = (gfun - 1)^2;               
    end
end