%function to check compatibility of the channel for the control goal

%Author: Pavan Tallapragada

function [ isflag, L3tu, Pc_nb, DatCap_upto_next_black, eps_r ] = ...
           is_channel_control_comp_J0( eps0, Par )

n = Par.n;
T0 = Par.T0;
Tslot = Par.Tslot;
Islot = Par.Islot;
Pbar = Par.Pbar;
R = Par.R;
nbs = Par.nbs;

w = Par.w;
W = Par.W;
theta = Par.theta;
theta_bar = Par.theta_bar;

tmp1 = ( exp(w*Tslot) - 1 )*( w+theta )./ ...
       ( W*( exp( (w+theta)*Tslot ) - 1 ) );

tmp2 = 1./exp(theta_bar*Tslot);
eps_tmp = min( tmp1, tmp2 );

N = length(R);

Pc_nb = zeros(1, N);
DatCap_upto_next_black = zeros(1,N);
eps_r = zeros(1,N);

if Pbar(1) == 0
    isflag = 0;
    return;
end

for k = 1:N    
    if nbs(k) == inf    %no blackout after slot k
        Pc_nb(k) = inf;
        DatCap_upto_next_black(k) = inf;
        eps_r(k) = inf;
    else
        [ phi_tmp, DataCap ] = data_cap_ind_J0( k, nbs(k)-1, Par );
        Pc_nb(k) = phi_tmp(1);
        DatCap_upto_next_black(k) = DataCap;
        eps_r(k) = eps_tmp(nbs(k));
    end
end

%list of blackout slots
bslot = unique(nbs);
bslot = bslot(bslot < inf);

nblackouts = length(bslot);

L3tu = ones(nblackouts,1);

L3tu(1) = L3fun( T0, eps0, 1, eps_r(1), DatCap_upto_next_black(1), Par );

for k = 1:nblackouts-1
    nxs = bslot(k) + 1;
    L3tu(k+1) = L3fun( Islot(nxs - 1), 1, nxs, eps_r(nxs), ...
                       DatCap_upto_next_black(nxs), Par );
end

if sum(L3tu > 1) > 0
    isflag = 0;
else
    isflag = 1;
end
